function SkirmishDefense:SceneTest()
--[[ THIS TEST IS DONE AUTOMATICALLY BY THE GAME NOW; IT SCANS THE SCRIPT FOR ANY MENTIONS OF "GetArea" AND TESTS THE SCENES FOR HAVING THOSE USED AREAS DEFINED!
	-- See if the required areas are present in the test scene
	if not (TestScene:HasArea("LZ Team 1") and TestScene:HasArea("LZ Team 2")) then
		-- If the test scene failed the compatibility test, invalidate it
		TestScene = nil;
	end
--]]
end

function SkirmishDefense:StartActivity()
	dofile("MoarFriends.rte/Factions.lua");







	print("START! -- SkirmishDefense:StartActivity()!");
	self.playertally = 0;
	self.playerlist = {};
    for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
        if self:PlayerActive(player) and self:PlayerHuman(player) then
		self.playerlist[player + 1] = true;
		self.playertally = self.playertally + 1;
		-- Check if we already have a brain assigned
			if not self:GetPlayerBrain(player) then
				local foundBrain = MovableMan:GetUnassignedBrain(self:GetTeamOfPlayer(player));
				-- If we can't find an unassigned brain in the scene to give each player, then force to go into editing mode to place one
				if not foundBrain then
					self.ActivityState = Activity.EDITING;
					AudioMan:ClearMusicQueue();
					AudioMan:PlayMusic("Base.rte/Music/dBSoundworks/ccambient4.ogg", -1, -1);
				else
					-- Set the found brain to be the selected actor at start
					self:SetPlayerBrain(foundBrain, player);
					self:SwitchToActor(foundBrain, player, self:GetTeamOfPlayer(player));
					self:SetLandingZone(self:GetPlayerBrain(player).Pos, player);
					-- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
					self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
				end
			end
		end
	end

	self.ESpawn1Timer = Timer();
	self.ESpawn2Timer = Timer();
	self.ESpawn3Timer = Timer();
	self.ESpawn4Timer = Timer();
	self.ESpawn5Timer = Timer();
	self.LZ = SceneMan.Scene:GetArea("LZ Team 1");
	self.EnemyLZ = SceneMan.Scene:GetArea("LZ Team 2");
	
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self:SetTeamFunds(10000, Activity.TEAM_1);
		self:SetTeamFunds(10000, Activity.TEAM_2);
		self:SetTeamFunds(10000, Activity.TEAM_3);
		self:SetTeamFunds(10000, Activity.TEAM_4);
		self.BaseSpawnTime = 6000;
		self.RandomSpawnTime = 8000;
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self:SetTeamFunds(8000, Activity.TEAM_1);
		self:SetTeamFunds(8000, Activity.TEAM_2);
		self:SetTeamFunds(8000, Activity.TEAM_3);
		self:SetTeamFunds(8000, Activity.TEAM_4);
		self.BaseSpawnTime = 5500;
		self.RandomSpawnTime = 7000;
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self:SetTeamFunds(6000, Activity.TEAM_1);
		self:SetTeamFunds(6000, Activity.TEAM_2);
		self:SetTeamFunds(6000, Activity.TEAM_3);
		self:SetTeamFunds(6000, Activity.TEAM_4);
		self.BaseSpawnTime = 5000;
		self.RandomSpawnTime = 6000;
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self:SetTeamFunds(4000, Activity.TEAM_1);
		self:SetTeamFunds(4000, Activity.TEAM_2);
		self:SetTeamFunds(4000, Activity.TEAM_3);
		self:SetTeamFunds(4000, Activity.TEAM_4);
		self.BaseSpawnTime = 4500;
		self.RandomSpawnTime = 5000;
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self:SetTeamFunds(2000, Activity.TEAM_1);
		self:SetTeamFunds(2000, Activity.TEAM_2);
		self:SetTeamFunds(2000, Activity.TEAM_3);
		self:SetTeamFunds(2000, Activity.TEAM_4);
		self.BaseSpawnTime = 4000;
		self.RandomSpawnTime = 4500;
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
		self:SetTeamFunds(1000, Activity.TEAM_1);
		self:SetTeamFunds(1000, Activity.TEAM_2);
		self:SetTeamFunds(1000, Activity.TEAM_3);
		self:SetTeamFunds(1000, Activity.TEAM_4);
		self.BaseSpawnTime = 3500;
		self.RandomSpawnTime = 4000;
	end

	self.StartTimer = Timer();
	self.TimeLeft1 = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
	self.TimeLeft2 = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
	self.TimeLeft3 = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
	self.TimeLeft4 = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
	self.TimeLeft5 = self.BaseSpawnTime + math.random(self.RandomSpawnTime);

	self.RED = 0;
	self.GREEN = 1;
	self.BLUE = 0;
	self.YELLOW = 0;
	self.NEUTRAL = 0;


		if UInputMan:KeyPressed(28) then
			self.RED = 1 - self.RED;
			print("RED: "..self.RED);
		end
		if UInputMan:KeyPressed(29) then
			self.GREEN = 1 - self.GREEN;
			print("GREEN: "..self.GREEN);
		end
		if UInputMan:KeyPressed(30) then
			self.BLUE = 1 - self.BLUE;
			print("BLUE: "..self.BLUE);
		end
		if UInputMan:KeyPressed(31) then
			self.YELLOW = 1 - self.YELLOW;
			print("YELLOW: "..self.YELLOW);
		end
		if UInputMan:KeyPressed(32) then
			self.NEUTRAL = 1 - self.NEUTRAL;
			print("NEUTRAL: "..self.NEUTRAL);
		end
end

function SkirmishDefense:PauseActivity(pause)
    	print("PAUSE! -- SkirmishDefense:PauseActivity()!");
end

function SkirmishDefense:EndActivity()
    	print("END! -- SkirmishDefense:EndActivity()!");
		
end

function SkirmishDefense:CreateCraft(actorside)

	if self.DropShipSets[actorside] ~= nil and self.RocketSets[actorside] ~= nil then
		local n = math.random();
		if n > 0.5 then
			return CreateACRocket(self.RocketSets[actorside][math.random(#self.RocketSets[actorside])], self.Modules[actorside]);
		else
			return CreateACDropShip(self.DropShipSets[actorside][math.random(#self.DropShipSets[actorside])], self.Modules[actorside]);
		end
	elseif self.DropShipSets[actorside] == nil and self.RocketSets[actorside] == nil then
		local z = math.random();
		if z > 0.90 then
			return CreateACRocket("Drop Crate","Dummy.rte");
		elseif z > 0.80 then
			return CreateACRocket("Rocklet","Dummy.rte");
		elseif z > 0.60 then
			return CreateACDropShip("Drop Ship","Dummy.rte");
		elseif z > 0.40 then
			return CreateACDropShip("Drop Ship MK1","Coalition.rte");
		elseif z > 0.20 then
			return CreateACRocket("Rocket MK2","Coalition.rte");
		else
			return CreateACRocket("Rocket MK1","Coalition.rte");
		end
	elseif self.DropShipSets[actorside] == nil and self.RocketSets[actorside] ~= nil then
		return CreateACRocket(self.RocketSets[actorside][math.random(#self.RocketSets[actorside])], self.Modules[actorside]);
	elseif self.DropShipSets[actorside] ~= nil and self.RocketSets[actorside] == nil then
		return CreateACDropShip(self.DropShipSets[actorside][math.random(#self.DropShipSets[actorside])], self.Modules[actorside]);
	end
end

function SkirmishDefense:UpdateActivity()

	if self.ActivityState ~= Activity.OVER and self.ActivityState ~= Activity.EDITING then

		-- Clear all objective markers, they get re-added each frame
		self:ClearObjectivePoints();

		for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
			if self:PlayerActive(player) and self:PlayerHuman(player) then
				if not self.StartTimer:IsPastSimMS(3000) then
					FrameMan:SetScreenText("Destroy the enemy brain(s)!", player, 333, 5000, true);
				end
				-- The current player's team
				local team = self:GetTeamOfPlayer(player);
				-- Check if any player's brain is dead
				if not MovableMan:IsActor(self:GetPlayerBrain(player)) then
					self:SetPlayerBrain(nil, player);
					self:ResetMessageTimer(player);
					FrameMan:ClearScreenText(player);
					FrameMan:SetScreenText("Your brain has been destroyed!", player, 333, -1, false);
					if self.playerlist[player + 1] == true then
						self.playerlist[player + 1] = false;
						self.playertally = self.playertally - 1;
					end
				else
					--Add objective points
					self:AddObjectivePoint("Protect!", self:GetPlayerBrain(player).AboveHUDPos, team, GameActivity.ARROWDOWN);
					for player2 = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
						if player2 ~= player and self:PlayerActive(player2) and self:PlayerHuman(player2) and MovableMan:IsActor(self:GetPlayerBrain(player2)) then
							local team2 = self:GetTeamOfPlayer(player2);
							self:AddObjectivePoint("Destroy!", self:GetPlayerBrain(player2).AboveHUDPos, team, GameActivity.ARROWDOWN);
						end
					end
				end
			end
		end

		if self.ESpawn1Timer:LeftTillSimMS(self.TimeLeft1) <= 0 and MovableMan:GetMOIDCount() <= 210 and self.GREEN == 1 then
			local actor = {};
			for x = 0, math.ceil(math.random(3)) do
				actor[x] = CreateAHuman(self.ActorSets[self.FriendsGreen][math.random(#self.ActorSets[self.FriendsGreen])]);
				actor[x].Team = 1;
				actor[x].AIMode = Actor.AIMODE_BRAINHUNT;
				if self.WeaponSets[self.FriendsGreen] ~= nil then
					actor[x]:AddInventoryItem(CreateHDFirearm(self.WeaponSets[self.FriendsGreen][math.random(#self.WeaponSets[self.FriendsGreen])]));
				end
				actor[x]:AddInventoryItem(CreateHDFirearm("Medium Digger"));
			end
			local ship = nil;
			ship = self:CreateCraft(self.FriendsGreen);
			ship.Team = 1;
			local w = math.random();
			if w > 0.5 then
				ship.Pos = Vector(self.EnemyLZ:GetRandomPoint().X,-50);
			else
				ship.Pos = Vector(self.LZ:GetRandomPoint().X,-50);
			end
			for n = 0, #actor do
				ship:AddInventoryItem(actor[n]);
			end
			MovableMan:AddActor(ship);
			self.ESpawn1Timer:Reset();
			self.TimeLeft1 = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
		end

		if self.ESpawn2Timer:LeftTillSimMS(self.TimeLeft2) <= 0 and MovableMan:GetMOIDCount() <= 210 and self.BLUE == 1 then
			local actor = {};
			for x = 0, math.ceil(math.random(3)) do
				actor[x] = CreateAHuman(self.ActorSets[self.FriendsBlue][math.random(#self.ActorSets[self.FriendsBlue])]);
				actor[x].Team = 2;
				actor[x].AIMode = Actor.AIMODE_BRAINHUNT;
				if self.WeaponSets[self.FriendsBlue] ~= nil then
					actor[x]:AddInventoryItem(CreateHDFirearm(self.WeaponSets[self.FriendsBlue][math.random(#self.WeaponSets[self.FriendsBlue])]));
				end
				actor[x]:AddInventoryItem(CreateHDFirearm("Medium Digger"));
			end
			local ship = nil;
			ship = self:CreateCraft(self.FriendsBlue);
			ship.Team = 2;
			local w = math.random();
			if w > 0.5 then
				ship.Pos = Vector(self.EnemyLZ:GetRandomPoint().X,-50);
			else
				ship.Pos = Vector(self.LZ:GetRandomPoint().X,-50);
			end
			for n = 0, #actor do
				ship:AddInventoryItem(actor[n]);
			end
			MovableMan:AddActor(ship);
			self.ESpawn2Timer:Reset();
			self.TimeLeft2 = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
		end

		if self.ESpawn3Timer:LeftTillSimMS(self.TimeLeft3) <= 0 and MovableMan:GetMOIDCount() <= 210 and self.YELLOW == 1 then
			local actor = {};
			for x = 0, math.ceil(math.random(3)) do
				actor[x] = CreateAHuman(self.ActorSets[self.FriendsYellow][math.random(#self.ActorSets[self.FriendsYellow])]);
				actor[x].Team = 3;
				actor[x].AIMode = Actor.AIMODE_BRAINHUNT;
				if self.WeaponSets[self.FriendsYellow] ~= nil then
					actor[x]:AddInventoryItem(CreateHDFirearm(self.WeaponSets[self.FriendsYellow][math.random(#self.WeaponSets[self.FriendsYellow])]));
				end
				actor[x]:AddInventoryItem(CreateHDFirearm("Medium Digger"));
			end
			local ship = nil;
			ship = self:CreateCraft(self.FriendsYellow);
			ship.Team = 3;
			local w = math.random();
			if w > 0.5 then
				ship.Pos = Vector(self.EnemyLZ:GetRandomPoint().X,-50);
			else
				ship.Pos = Vector(self.LZ:GetRandomPoint().X,-50);
			end
			for n = 0, #actor do
				ship:AddInventoryItem(actor[n]);
			end
			MovableMan:AddActor(ship);
			self.ESpawn3Timer:Reset();
			self.TimeLeft3 = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
		end

		if self.ESpawn4Timer:LeftTillSimMS(self.TimeLeft4) <= 0 and MovableMan:GetMOIDCount() <= 210 and self.RED == 1 then
			local actor = {};
			for x = 0, math.ceil(math.random(3)) do
				actor[x] = CreateAHuman(self.ActorSets[self.FriendsRed][math.random(#self.ActorSets[self.FriendsRed])]);
				actor[x].Team = 0;
				actor[x].AIMode = Actor.AIMODE_PATROL;
				if self.WeaponSets[self.FriendsRed] ~= nil then
					actor[x]:AddInventoryItem(CreateHDFirearm(self.WeaponSets[self.FriendsRed][math.random(#self.WeaponSets[self.FriendsRed])]));
				end
				actor[x]:AddInventoryItem(CreateHDFirearm("Medium Digger"));
			end
			local ship = nil;
			ship = self:CreateCraft(self.FriendsRed);
			ship.Team = 0;
			local w = math.random();
			if w > 0.5 then
				ship.Pos = Vector(self.EnemyLZ:GetRandomPoint().X,-50);
			else
				ship.Pos = Vector(self.LZ:GetRandomPoint().X,-50);
			end
			for n = 0, #actor do
				ship:AddInventoryItem(actor[n]);
			end
			MovableMan:AddActor(ship);
			self.ESpawn4Timer:Reset();
			self.TimeLeft4 = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
		end

		if self.ESpawn5Timer:LeftTillSimMS(self.TimeLeft5) <= 0 and MovableMan:GetMOIDCount() <= 210 and self.NEUTRAL == 1 then
			local actor = {};
			for x = 0, math.ceil(math.random(3)) do
				actor[x] = CreateAHuman(self.ActorSets[self.FriendsNeutral][math.random(#self.ActorSets[self.FriendsNeutral])]);
				actor[x].Team = -1;
				actor[x].AIMode = Actor.AIMODE_BRAINHUNT;
				if self.WeaponSets[self.FriendsNeutral] ~= nil then
					actor[x]:AddInventoryItem(CreateHDFirearm(self.WeaponSets[self.FriendsNeutral][math.random(#self.WeaponSets[self.FriendsNeutral])]));
				end
				actor[x]:AddInventoryItem(CreateHDFirearm("Medium Digger"));
			end
			local ship = nil;
			ship = self:CreateCraft(self.FriendsNeutral);
			ship.Team = -1;
			local w = math.random();
			if w > 0.5 then
				ship.Pos = Vector(self.EnemyLZ:GetRandomPoint().X,-50);
			else
				ship.Pos = Vector(self.LZ:GetRandomPoint().X,-50);
			end
			for n = 0, #actor do
				ship:AddInventoryItem(actor[n]);
			end
			MovableMan:AddActor(ship);
			self.ESpawn5Timer:Reset();
			self.TimeLeft5 = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
		end

		if self.ESpawn4Timer:LeftTillSimMS(self.TimeLeft5) <= 0 and RED == 0 then
			self.ESpawn4Timer:Reset();
			self.TimeLeft4 = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
		end
		if self.ESpawn1Timer:LeftTillSimMS(self.TimeLeft1) <= 0 and GREEN == 0 then
			self.ESpawn1Timer:Reset();
			self.TimeLeft1 = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
		end

		if self.ESpawn2Timer:LeftTillSimMS(self.TimeLeft2) <= 0 and BLUE == 0 then
			self.ESpawn2Timer:Reset();
			self.TimeLeft2 = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
		end
		if self.ESpawn3Timer:LeftTillSimMS(self.TimeLeft3) <= 0 and YELLOW == 0 then
			self.ESpawn3Timer:Reset();
			self.TimeLeft3 = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
		end
		if self.ESpawn5Timer:LeftTillSimMS(self.TimeLeft5) <= 0 and NEUTRAL == 0 then
			self.ESpawn5Timer:Reset();
			self.TimeLeft5 = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
		end

		if UInputMan:KeyPressed(28) then
			self.RED = 1 - self.RED;
			print("RED: "..self.RED);
		end
		if UInputMan:KeyPressed(29) then
			self.GREEN = 1 - self.GREEN;
			print("GREEN: "..self.GREEN);
		end
		if UInputMan:KeyPressed(30) then
			self.BLUE = 1 - self.BLUE;
			print("BLUE: "..self.BLUE);
		end
		if UInputMan:KeyPressed(31) then
			self.YELLOW = 1 - self.YELLOW;
			print("YELLOW: "..self.YELLOW);
		end
		if UInputMan:KeyPressed(32) then
			self.NEUTRAL = 1 - self.NEUTRAL;
			print("NEUTRAL: "..self.NEUTRAL);
		end



		--Win/Lose Conditions
		if self.CPUTeam == Activity.NOTEAM then
			if self.playertally == 1 then
				for i = 1, #self.playerlist do
					if self.playerlist[i] == true then
						self.WinnerTeam = i - 1;
						ActivityMan:EndActivity();
					end
				end
			end
		else
			if self.playertally == 0 then
				self.WinnerTeam = self.CPUTeam;
				ActivityMan:EndActivity();
			end
		end
	else
		self.StartTimer:Reset();
	end
end